#include<stdio.h>

/* We do a lazy kind of wrapping, where whitespace stays on the end unless
 * it is what triggered the wrap, in which case it gets diked.
 */

main(int argc, char **argv)
	{
	char str[256];
	FILE *ifd, *ofd;
	int maxcol, col, i, c;
	if(argc!=4)
		{
		printf("USAGE: wordwrap <infile> <outfile> <column>\n"
			"(<column> is the one-indexed last legal column.)\n");
		exit(1);
		}
	maxcol=atoi(argv[3]);
	if(maxcol>255)
		{
		printf("<column> argument must be <=255.\n");
		exit(4);
		}
	if((ifd=fopen(argv[1], "r"))==NULL)
		{
		printf("Error opening %s for input.\n", argv[1]);
		exit(2);
		}
	if((ofd=fopen(argv[2], "w"))==NULL)
		{
		printf("Error opening %s for output.\n", argv[2]);
		exit(3);
		}
	for(i=col=0;;)
		{
		if((c=getc(ifd))==EOF)
			break;
		if(c=='\n')
			{
			if(i)
				{
				str[i]='\0';
				fputs(str, ofd);
				i=col=0;
				}
			putc('\n', ofd);
			}
		else if(c==' ')
			{
			str[i]='\0';
			fputs(str, ofd);
			i=0;
			if((++col)>maxcol)
				{
				putc('\n', ofd);
				col=0;
				}
			else
				putc(' ', ofd);
			}
		else if(c=='\t')
			{
			str[i]='\0';
			fputs(str, ofd);
			i=0;
			if((col+=8)>maxcol)
				{
				putc('\n', ofd);
				col=0;
				}
			else
				putc('\t', ofd);
			}
		else
			{
			str[i++]=c;
			if(i>=maxcol)
				{
				str[i]='\0';
				fputs(str, ofd);
				putc('\n', ofd);
				i=col=0;
				}
			else if((++col)>maxcol)
				{
				putc('\n', ofd);
				col=0;
				}
			}
		}
	if(i)
		{
		str[i]='\0';
		fputs(str, ofd);
		putc('\n', ofd);
		}
	fclose(ifd);
	fclose(ofd);
	exit(0);
	}